/*
   File: qtsioctl.h

   The particulars of the QTS-195 Control IOCTL's

*/

#ifndef _DEFINED_7D66A2B6_DD69_4bbb_9718_6A4F6F1CAB96
#define _DEFINED_7D66A2B6_DD69_4bbb_9718_6A4F6F1CAB96

// Microsoft supplied file from DDK
#include "DevIOCtl.h"


#define QTSDONGLE_IOCTL_INDEX  0x0800


#define IOCTL_QTSDONGLE_GET_PIPE_INFO           CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_DEVICE_DESCRIPTOR   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+1,\
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_CONFIG_DESCRIPTOR   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+2, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_REGISTER_NOTIFY_EVENT   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+4, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)                                                   
#define IOCTL_QTSDONGLE_RESET_DEVICE            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+5, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)                                                              
#define IOCTL_QTSDONGLE_RESET_PIPE              CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+6, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_GET_DRIVER_REVISION     CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+7, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)  

#define IOCTL_QTSDONGLE_GET_STRING_DESCRIPTOR   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+8, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_IS_DONGLE_ALIVE         CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+9, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)  

#define IOCTL_QTSDONGLE_SEND_KEY                CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0A, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_KEY                 CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0B, \
                                                METHOD_BUFFERED,  \
                                                FILE_ANY_ACCESS)
                                                         
#define IOCTL_QTSDONGLE_WRITE_PORT              CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0C, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_READ_EEPROM             CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0E, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_WRITE_EEPROM            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0F, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)
#ifdef MWADMIN 
#define IOCTL_QTSDONGLE_SEND_PASS               CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x10, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)
#endif
#define IOCTL_QTSDONGLE_GET_SECURITY_STATE      CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x11, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_RESET_SECURITY_STATE    CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x12, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_GET_KEY_STATE           CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x13, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_RESET_KEY_STATE         CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x14, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_SEND_HOST_VERIFY_REQUEST \
                                                CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x15, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_REQUEST_PAGE            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x16, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_GET_PAGE_FLAGS          CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x17, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_GET_TWC_FLAG            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x18, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS) 

#define IOCTL_QTSDONGLE_GET_BUSY_FLAG           CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x19, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_EEPROM_ERROR_FLAG   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1A, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)
#ifdef MWADMIN
#define IOCTL_QTSDONGLE_EEPROM_INVALIDATE       CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1B, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)
#endif
#define IOCTL_QTSDONGLE_SOFT_RESET              CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1C, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_SEND_PORT               CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1D, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)


#define IOCTL_QTSDONGLE_GET_FLAGS               CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1E, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)


#endif // #ifndef _DEFINED_7D66A2B6_DD69_4bbb_9718_6A4F6F1CAB96